//---------------------------------------------------------------------------
// Processes.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Processes.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Processes {
//---------------------------------------------------------------------------
__fastcall TThreadInputAttachment::TThreadInputAttachment(DWORD ASrcId, DWORD ADstId, bool AAttach) :
	FSrcId(ASrcId),
	FDstId(ADstId),
	FAttachCount(0)
{
	if(AAttach) {
		Attach();
	}
}
//---------------------------------------------------------------------------
__fastcall TThreadInputAttachment::~TThreadInputAttachment()
{
	while(IsAttached()) {
		Detach();
	}
}
//---------------------------------------------------------------------------
void __fastcall TThreadInputAttachment::Attach()
{
	if(FSrcId != FDstId && !::AttachThreadInput(FSrcId, FDstId, true)) {
		throw EProcessError("The program cannot attach the thread input.");
	}
	FAttachCount++;
}
//---------------------------------------------------------------------------
void __fastcall TThreadInputAttachment::Detach()
{
	if(!IsAttached()) {
		return;
	}
	if(FSrcId != FDstId) {
		::AttachThreadInput(FSrcId, FDstId, false);
	}
	FAttachCount--;
}
//---------------------------------------------------------------------------
bool __fastcall TThreadInputAttachment::IsAttached() const
{
	return FAttachCount > 0;
}
//---------------------------------------------------------------------------
BOOL __fastcall ForceSetForegroundWindow(HWND AWindow)
{
	TThreadInputAttachment attachment(
		::GetWindowThreadProcessId(AWindow, NULL),
		::GetWindowThreadProcessId(::GetForegroundWindow(), NULL));
	return ::SetForegroundWindow(AWindow);
}
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Processes
//---------------------------------------------------------------------------

