//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Processes_H
#define Moochos_Moa_Processes_H
//---------------------------------------------------------------------------
// Processes.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Processes {
//---------------------------------------------------------------------------
class EProcessError : public Exception
{
public:
	__fastcall EProcessError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TThreadInputAttachment
{
private:
	DWORD FSrcId;
	DWORD FDstId;
	int FAttachCount;
	__fastcall TThreadInputAttachment(const TThreadInputAttachment& AOther); // Forbidden
	TThreadInputAttachment& __fastcall operator =(const TThreadInputAttachment& AOther); // Forbidden
protected:
public:
	__fastcall TThreadInputAttachment(DWORD ASrcId, DWORD ADstId, bool AAttach = true);
	__fastcall ~TThreadInputAttachment();
	void __fastcall Attach();
	void __fastcall Detach();
	bool __fastcall IsAttached() const;
};
//---------------------------------------------------------------------------
extern BOOL __fastcall ForceSetForegroundWindow(HWND AWindow);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Processes
using namespace Moochos::Moa::Processes;
//---------------------------------------------------------------------------
#endif

