//---------------------------------------------------------------------------
// Windows2.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Windows2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Windows2 {
//---------------------------------------------------------------------------
void __fastcall TMessageWindow::Initialize()
{
	try {
		FHandle = AllocateHWnd(WndProc);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMessageWindow::Uninitialize()
{
	if(FHandle != NULL) {
		DeallocateHWnd(FHandle);
		FHandle = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMessageWindow::WndProc(TMessage& AMessage)
{
	DoMessage(AMessage);
	AMessage.Result = ::DefWindowProc(Handle, AMessage.Msg, AMessage.WParam, AMessage.LParam);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWindow::DoMessage(TMessage& AMessage)
{
	if(OnMessage != NULL) {
		OnMessage(this, AMessage);
	}
}
//---------------------------------------------------------------------------
__fastcall TMessageWindow::TMessageWindow() :
	TObject(),
	FHandle(NULL),
	FOnMessage(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TMessageWindow::~TMessageWindow()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
HWND __fastcall EnsureGetParent(HWND hWnd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetParent(hWnd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError("The program cannot get the parent window.");
	}
	return returnValue;
}
//---------------------------------------------------------------------------
HWND __fastcall EnsureGetWindow(HWND hWnd, UINT uCmd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetWindow(hWnd, uCmd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError("The program cannot get the window.");
	}
	return returnValue;
}
//---------------------------------------------------------------------------
LONG_PTR __fastcall EnsureGetWindowLongPtr(HWND hWnd, int nIndex)
{
	::SetLastError(NO_ERROR);
	LONG_PTR returnValue = ::GetWindowLongPtr(hWnd, nIndex);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError("The program cannot get the window information.");
	}
	return returnValue;
}
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Windows2
//---------------------------------------------------------------------------

