//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Windows2_H
#define Moochos_Moa_Windows2_H
//---------------------------------------------------------------------------
// Windows2.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Windows2 {
//---------------------------------------------------------------------------
class EWindowError : public Exception
{
public:
	__fastcall EWindowError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TMessageWindow : public TObject
{
public:
	typedef void __fastcall (__closure * TMessageEvent)(TObject* ASender, TMessage& AMessage);
private:
	HWND FHandle;
	TMessageEvent FOnMessage;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall WndProc(TMessage& AMessage);
	void __fastcall DoMessage(TMessage& AMessage);
protected:
public:
	__fastcall TMessageWindow();
	virtual __fastcall ~TMessageWindow();
	__property HWND Handle = {read=FHandle};
	__property TMessageEvent OnMessage = {read=FOnMessage, write=FOnMessage};
};
//---------------------------------------------------------------------------
extern HWND __fastcall EnsureGetParent(HWND hWnd);
extern HWND __fastcall EnsureGetWindow(HWND hWnd, UINT uCmd);
extern LONG_PTR __fastcall EnsureGetWindowLongPtr(HWND hWnd, int nIndex);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Windows2
using namespace Moochos::Moa::Windows2;
//---------------------------------------------------------------------------
#endif

