//---------------------------------------------------------------------------
#ifndef Moochos_WheelHere_MainFormUnit_H
#define Moochos_WheelHere_MainFormUnit_H
//---------------------------------------------------------------------------
// MainFormUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include "Lib/Moochos/Moa/Taskbar.h"
#include "Lib/Moochos/Moa/Windows2.h"
#include "HelpHandler.h"
#include "SettingsHandler.h"
#include "WheelHook.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TAction* MainFormActivateApplicationAc;
	TAction* MainFormShowMenuAc;
	TAction* MainFormShowOptionsAc;
	TAction* MainFormExitAc;
	TAction* HelpShowContentsAc;
	TAction* HelpShowAboutAc;
	TAction* SettingsShowOptionsAc;
	TActionList* ActionList1;
	TImageList* ImageList1;
	TMenuItem* MenuItem1;
	TMenuItem* MenuItem2;
	TMenuItem* MenuItem21;
	TMenuItem* MenuItem22;
	TMenuItem* MenuItem23;
	TMenuItem* MenuItem3;
	TMenuItem* MenuItem4;
	TPopupMenu* PopupMenu1;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall ActionList1Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall MainFormActivateApplicationAcExecute(TObject* ASender);
	void __fastcall MainFormShowMenuAcExecute(TObject* ASender);
	void __fastcall MainFormShowOptionsAcExecute(TObject* ASender);
	void __fastcall MainFormExitAcExecute(TObject* ASender);
	void __fastcall SettingsShowOptionsAcExecute(TObject* ASender);
	void __fastcall HelpShowContentsAcExecute(TObject* ASender);
	void __fastcall HelpShowAboutAcExecute(TObject* ASender);
public:
	static const UINT WM_MULTIPLEAPPINSTANCES;
private:
	THelpHandler* FHelpHandler;
	TSettingsHandler* FSettingsHandler;
	TWheelHook* FWheelHook;
	TNotificationIcon* FNotificationIcon;
	TMessageWindow* FProcessMessenger;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall WheelHookChange(TObject* ASender);
	void __fastcall NotificationIconMessage(TObject* ASender, UINT AKind);
	void __fastcall ProcessMessengerMessage(TObject* ASender, TMessage& AMessage);
protected:
public:
	virtual __fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	__property THelpHandler* HelpHandler = {read=FHelpHandler};
	__property TSettingsHandler* SettingsHandler = {read=FSettingsHandler};
	__property TWheelHook* WheelHook = {read=FWheelHook};
	__property TNotificationIcon* NotificationIcon = {read=FNotificationIcon};
	__property TMessageWindow* ProcessMessenger = {read=FProcessMessenger};
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif

