//---------------------------------------------------------------------------
#ifndef Moochos_WheelHere_SettingsHandler_H
#define Moochos_WheelHere_SettingsHandler_H
//---------------------------------------------------------------------------
// SettingsHandler.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Moochos { namespace Moa { namespace IniFiles { class TVarIniFile; }}} using namespace Moochos::Moa::IniFiles;
class TOptionsDialog;
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace SettingsHandler {
//---------------------------------------------------------------------------
class ESettingsHandlerError : public Exception
{
public:
	__fastcall ESettingsHandlerError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
struct TSettings
{
	struct
	{
		bool Enabled;
		bool Focus;
		bool Scroll;
	} MouseWheel;
	struct
	{
		bool DisplayIcon;
	} View;
};
//---------------------------------------------------------------------------
class TSettingsHandler : public TObject
{
private:
	TSettings __fastcall LoadFromFile(TVarIniFile* AIniFile);
	void __fastcall SaveToFile(TVarIniFile* AIniFile, const TSettings& ASettings);
	void __fastcall OptionsDialogApply(TObject* ASender);
	TSettings __fastcall GetSettings();
	void __fastcall SetSettings(const TSettings& ASettings);
	TSettings __fastcall GetOptions();
	void __fastcall SetOptions(const TSettings& AOptions);
	TSettings __fastcall GetSettingsAs(bool AAsSettings);
	void __fastcall SetSettingsAs(const TSettings& ASettings, bool AAsSettings);
protected:
public:
	__fastcall TSettingsHandler();
	virtual __fastcall ~TSettingsHandler();
	void __fastcall Load();
	void __fastcall Save();
	void __fastcall Reset();
	void __fastcall ShowOptions();
	__property TSettings Settings = {read=GetSettings, write=SetSettings};
	__property TSettings Options = {read=GetOptions, write=SetOptions};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::WheelHere::SettingsHandler
using namespace Moochos::WheelHere::SettingsHandler;
//---------------------------------------------------------------------------
#endif

