//---------------------------------------------------------------------------
#ifndef Moochos_WheelHere_Wheeler_ScrollSnap_H
#define Moochos_WheelHere_Wheeler_ScrollSnap_H
//---------------------------------------------------------------------------
// ScrollSnap.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace Wheeler { namespace ScrollSnap {
//---------------------------------------------------------------------------
class TScrollBarSnap
{
private:
	int FMin;
	int FMax;
	int FPosition;
	int FPage;
	bool FAvailable;
	void Update(HWND AWindow, int AKind);
protected:
public:
	TScrollBarSnap(HWND AWindow, int AKind);
	TScrollBarSnap();
	~TScrollBarSnap();
	bool operator ==(const TScrollBarSnap& AOther) const;
	bool operator !=(const TScrollBarSnap& AOther) const;
	bool CanScroll() const;
	bool CanScrollTo(bool AForward) const;
	__property int Min = {read=FMin};
	__property int Max = {read=FMax};
	__property int Position = {read=FPosition};
	__property int Page = {read=FPage};
	__property bool Available = {read=FAvailable};
};
//---------------------------------------------------------------------------
class TScrollSnap
{
private:
	TScrollBarSnap FControlSnap;
	TScrollBarSnap FHorzBarSnap;
	TScrollBarSnap FVertBarSnap;
	bool FHorzControl;
protected:
public:
	TScrollSnap(HWND AWindow);
	TScrollSnap();
	~TScrollSnap();
	bool operator ==(const TScrollSnap& AOther) const;
	bool operator !=(const TScrollSnap& AOther) const;
	bool CanScroll() const;
	__property TScrollBarSnap ControlSnap = {read=FControlSnap};
	__property TScrollBarSnap HorzBarSnap = {read=FHorzBarSnap};
	__property TScrollBarSnap VertBarSnap = {read=FVertBarSnap};
	__property bool HorzControl = {read=FHorzControl};
};
//---------------------------------------------------------------------------
}}}} // End of namespace Moochos::WheelHere::Wheeler::ScrollSnap
using namespace Moochos::WheelHere::Wheeler::ScrollSnap;
//---------------------------------------------------------------------------
#endif

