//---------------------------------------------------------------------------
// SystemSnap.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop
#include "SystemSnap.h"
#include "WheelCommon.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace Wheeler { namespace SystemSnap {
//---------------------------------------------------------------------------
void TSystemSnap::Update()
{
	UINT wheelScrollLines = 0;
	if(!::SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, &wheelScrollLines, 0)) {
		throw EWindowError();
	}
	FScrollLineCount = wheelScrollLines;
}
//---------------------------------------------------------------------------
bool TSystemSnap::GetScrollByPage() const
{
	// WHEEL_PAGESCROLL is defined as UINT_MAX in "winuser.h". However, Tweak
	// UI assigns 65535 instead of UINT_MAX. This program supports the latter
	// to ensure a wide range of use.
	return ScrollLineCount >= 65535;
}
//---------------------------------------------------------------------------
TSystemSnap::TSystemSnap(bool AUpdate) :
	FScrollLineCount(0)
{
	if(AUpdate) {
		Update();
	}
}
//---------------------------------------------------------------------------
TSystemSnap::TSystemSnap() :
	FScrollLineCount(0)
{
	// Do nothing
}
//---------------------------------------------------------------------------
TSystemSnap::~TSystemSnap()
{
	// Do nothing
}
//---------------------------------------------------------------------------
}}}} // End of namespace Moochos::WheelHere::Wheeler::SystemSnap
//---------------------------------------------------------------------------

