//---------------------------------------------------------------------------
// WheelCommon.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop
#include "WheelCommon.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace Wheeler { namespace WheelCommon {
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
} // End of namespace
//---------------------------------------------------------------------------
BOOL ForceSetForegroundWindow(HWND AWindow)
{
	DWORD srcId = ::GetWindowThreadProcessId(AWindow, NULL);
	DWORD dstId = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
	if(srcId != dstId && !::AttachThreadInput(srcId, dstId, true)) {
		throw EWindowError();
	}
	BOOL returnValue = ::SetForegroundWindow(AWindow);
	if(srcId != dstId && !::AttachThreadInput(srcId, dstId, false)) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
HWND EnsureGetParent(HWND hWnd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetParent(hWnd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
HWND EnsureGetWindow(HWND hWnd, UINT uCmd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetWindow(hWnd, uCmd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
LONG_PTR EnsureGetWindowLongPtr(HWND hWnd, int nIndex)
{
	::SetLastError(NO_ERROR);
	LONG_PTR returnValue = ::GetWindowLongPtr(hWnd, nIndex);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
POINT MakePoint(LONG AX, LONG AY)
{
	POINT point;
	point.x = AX;
	point.y = AY;
	return point;
}
//---------------------------------------------------------------------------
}}}} // End of namespace Moochos::WheelHere::Wheeler::WheelCommon
using namespace Moochos::WheelHere::Wheeler::WheelCommon;
//---------------------------------------------------------------------------

